----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    17:38:22 08/18/2011 
-- Design Name: 
-- Module Name:    Test2 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.numeric_std.all;


entity Test2 is
    Port ( RESET : in  STD_LOGIC;
           CLOCK : in  STD_LOGIC;
			  DB : OUT STD_LOGIC_VECTOR(7 DOWNTO 0));
end Test2;

architecture Behavioral of Test2 is
COMPONENT BRAM
  PORT (
    clka : IN STD_LOGIC;
    wea : IN STD_LOGIC_VECTOR(0 DOWNTO 0);
    addra : IN STD_LOGIC_VECTOR(3 DOWNTO 0);
    dina : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    douta : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)
  );
END COMPONENT;

signal RW : STD_LOGIC_VECTOR(0 DOWNTO 0) := (others => '0');
signal ADDR : STD_LOGIC_VECTOR(3 DOWNTO 0):=(others => '0');
signal DATAR : STD_LOGIC_VECTOR(7 DOWNTO 0):=(others => '0');
signal DATAW : STD_LOGIC_VECTOR(7 DOWNTO 0):=(others => '0');

signal STATE : STD_LOGIC :='0';
signal COUNT : STD_LOGIC_VECTOR(31 DOWNTO 0):=(others => '0');
begin

  MyBRAM : BRAM
  PORT MAP (
    clka => CLOCK,
    wea => RW,
    addra => ADDR,
    dina => DATAW,
    douta => DATAR
  );
		MAIN: process (CLOCK,RESET)
		begin
			if RESET = '1' then
				STATE <= '0';
				COUNT <= (others => '0');
			elsif rising_edge(CLOCK) then
				COUNT <= COUNT + 1;
				
				if(COUNT = 16000000) then
					ADDR <= (others => '0');
					DATAW <= "10101010";
					
					if(STATE = '0') then
						RW <= (others => '1');
						DATAR <= (others => '0');
						STATE <= '1';
					else
						RW <= (others => '0');
						STATE <= '0';
						DB <= DATAR;
					end if;
					
					COUNT <= (others => '0');
					
				end if;
			end if;
		end process;
		
end Behavioral;

